#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
	int count, i, tochild[2], fromchild[2];
	int pid, status;
	char buffer[10];
	unsigned int begin ,end;
	double timePer;
	unsigned int regr;
	asm volatile("mrc p15, 0, %0, c9, c14, 0" : "=r" (regr));
	printf("regr: %x\n", regr);

	count = 1000;
	pipe(tochild);
	for (i = 0; i < count; i++)
	{
		pid = fork();
		if (pid == 0) {
			read(tochild[0], buffer, 1);
			//if (buffer[0] != 'a') {
			//	printf("Exiting\n");
			//	return -1;
			//}
			//printf("end: %u\n", end);
			exit(0);
		} else if (pid == -1) {
			printf("Couldn't fork slave process: error %d.\n");
			return -1;
		} else {
			write(tochild[1], "a", 1);
			asm volatile("mrc p15, 0, %0, c9, c13, 0" : "=r" (begin));
			waitpid(pid, &status, 0);
			asm volatile("mrc p15, 0, %0, c9, c13, 0" : "=r" (end));
			//usleep(10000);
//			printf("Time: %u\n", end-begin);
			timePer+=(end-begin);
		}

	}
	timePer = timePer/(2*900*count);
	printf("Average time for context switch: %.lf seconds.\n", timePer);
}
