
#ifndef __RASPERF_H__
#define NULL '\0'
#define __RASPERF_H__
#define RTT 35 //in MicroSec
#define PI 0
#define x86 1
#define CPU_CYCLES 900 
#define MHz 1e6
#if defined(PI) && PI
#define time unsigned int
#define getTime(var) \
	asm volatile (\
	"mrc p15, 0, %0, c9, c13, 0":\
	"=r" (var));
#define readCCNTStatus(var) \
	asm volatile (\
	"mrc p15, 0, %0, c9, c14, 0":\
	"=r" (var));
#define diff(end, begin) \
        (end - begin)/ CPU_CYCLES};
#endif
#if defined(x86) && x86
#define time struct timeval
#define getTime(var) gettimeofday(&var, NULL)
#define diff(end, begin) \
	((end.tv_sec*1e6+end.tv_usec) - (begin.tv_sec*1e6+ begin.tv_usec))
#endif
#endif

