#define _GNU_SOURCE
#include <stdio.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>
#define BLOCK_SIZE 512

void main()
{
	char *fnames[] = {"file1", "file2", "file3", "file4", "file5", "file6", "file7"};
	char buffer[BLOCK_SIZE] __attribute__ ((__aligned__ (512)));
	struct timeval start, end;
	int fd=0, count = 0;
	int i, j;
	unsigned long long time;
	int status;
	for (i = 0; i < 7; i++) {
		count = 0; //count number of blocks
		printf("File %d: %s\n", i, fnames[i]);
		fflush(NULL);
		fd = open(fnames[i], O_RDONLY | O_DIRECT);
		if (!fd) {
			printf("unable to open\n");
			exit(0);
		}
		posix_fadvise(fd, 0, 0, POSIX_FADV_RANDOM);
		printf("You are here\n");
		gettimeofday(&start, NULL);
		for (j = 0; j < 10; j++) {
			count = 0;
			while(BLOCK_SIZE == read(fd, buffer, BLOCK_SIZE)) {
				count++;
			}
			lseek(fd, 0, SEEK_SET);
		}
		gettimeofday(&end, NULL);
		printf("You are here2\n");
		time = (end.tv_sec*1e6+end.tv_usec) - (start.tv_sec*1e6+start.tv_usec);
		printf("timestamp %llu - %llu\n", end.tv_sec*1e6+end.tv_usec, start.tv_sec*1e6+start.tv_usec);
		printf("time taken to read file # %d - %f\n", i, time/((float)count*10));

		sync();
		status = system("sudo /sbin/sysctl vm.drop_caches=3");
		sync();

		gettimeofday(&start, NULL);
		for (j = 0; j < 1000; j++) {
			pread(fd, buffer, BLOCK_SIZE, BLOCK_SIZE*(rand()%count));
		}
		gettimeofday(&end, NULL);
		time = (end.tv_sec*1e6+end.tv_usec) - (start.tv_sec*1e6+start.tv_usec);
		printf("timestamp %llu - %llu\n", end.tv_sec*1e6+end.tv_usec, start.tv_sec*1e6+start.tv_usec);
		printf("time taken to read file # %d - %f\n", i, time/1000.0);

		sync();
		status = system("sudo /sbin/sysctl vm.drop_caches=3");
		sync();
	}
}
