#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>

#define KB 1024
#define MB 1024 * KB
#define CPU_FREQ 900

// This will occupy 8 MB in memory
int array[2 * MB] = {1, 2, 3, 4, 5, 6};

int main()
{
	struct timeval start, end;
	struct timezone tz;
	int i, j;
	double avg = 0;
	register volatile temp1, temp2, temp3, temp4;
	gettimeofday(&start, &tz);	
	for (i = 0; i < 2 * MB; i += 32) {
		temp1 = i;
		temp2 = i + 8;
		temp3 = i + 16;
		temp4 = i + 24;
		/*		temp2 = array[i + MB];
				temp3 = array[i + 8];
				temp4 = array[i + 8 + MB];
				temp5 = array[i + 16];
				temp6 = array[i + 16 + MB];
				temp7 = array[i + 24];
				temp8 = array[i + 24 + MB];
		 */	
	}
	gettimeofday(&end, &tz);
	double delta_time = (end.tv_sec*1e6 + end.tv_usec) - (start.tv_sec*1e6 + start.tv_usec); 
	double bw = 8 * MB;
	double overhead = (33 * 1000)/900;
	double time_taken = (delta_time * 1000);
	printf("delta_time: %g, overhead: %g\n", delta_time, overhead);
	printf("Bandwidth: %gMBps\n", (bw * 1.0)/time_taken);
	avg += (bw * 1.0)/time_taken;
	return 0;
}
